# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core import jsontools
from core.item import Item
from servers import servertools

DEBUG = config.get_setting("debug")

__category__ = "F"
__type__ = "generic"
__title__ = "PlayMax"
__channel__ = "playmax"
__language__ = "ES"
__creationdate__ = "20141217"

host = "http://playmax.es/"

def isGeneric():
    return True

def openconfig(item):
    if "xbmc" in config.get_platform() or "boxee" in config.get_platform():
        config.open_settings( )
    return []

def mainlist(item):
    logger.info("pelisalacarta.channels.playmax mainlist")

    itemlist = []

    ## Sólo sería necesario 'login' en findvideos. El que no esté registrado podrá ojear pero no podrá ver los enlaces a los vídeos
    if config.get_setting("playmaxaccount")!="true":
        itemlist.append( Item( channel=__channel__ , title="Habilita tu cuenta para poder ver los enlaces a los vídeos..." , action="openconfig" , url="" , folder=False ) )
    else:
        login()
    itemlist.append( Item(channel=__channel__, action="fichas", title="Catálogo", url=host ))
    itemlist.append( Item(channel=__channel__, action="fichas", title="Series", url=host + "catalogo.php?tipo=1" ))
    itemlist.append( Item(channel=__channel__, action="fichas", title="Películas", url=host + "catalogo.php?tipo=2" ))
    itemlist.append( Item(channel=__channel__, action="fichas", title="Documentales", url=host + "catalogo.php?tipo=3" ))
    itemlist.append( Item(channel=__channel__, action="search", title="Buscar" ))

    return itemlist

def search(item, texto):
    logger.info("pelisalacarta.channels.playmax search")

    texto = texto.replace(" ","+")
    item.url = host + "buscar.php?buscar=%s&tipo=Buscar&valuesearch=0" % (texto)

    ## fichas necesita saber si es una búsqueda
    item.extra = "search"
    try:
        return fichas(item)
    ## Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

def fichas(item):
    logger.info("pelisalacarta.channels.playmax fichas")

    itemlist = []

    ## Descarga la página
    data = scrapertools.downloadpageWithoutCookies(item.url)
    #data = scrapertools.cache_page(item.url)
    ## Agrupa los datos
    data = re.sub(r'\n|\r|\t|&nbsp;|<br>','',data)
    data = re.sub(r'\s+',' ',data)
    data = re.sub(r'<!--.*?-->','',data)

    ## Es una búsqueda?
    if item.extra == "search":
        #<div style="height: 150px; margin-top: 10px;margin-bottom: 20px;"><div class="searchsinopsis" style="width: calc(100% - 110px); float: right; position: relative; text-align: justify;"><span style="position: absolute;right: 0px;width: 105px;"><span style="float: left; position:relative; display: block; width: 80px; height: 16px; background: url(./styles/prosilver/imageset/evaluation_darck.png); background-repeat: repeat-x;"><span style="position:relative; display: block; height: 16px; width: 92.111111111111%; background: url(./styles/prosilver/imageset/evaluation_light.png); background-repeat: repeat-x;"></span></span><div style="font-weight: bold;color: #f77f00;padding: 0px;float: right; font-family: arial; width: 22px; text-align: center;">9.2</div></span><h3 style="margin-top: -3px; padding-bottom: 5px;"><a href="./the-big-bang-theory-f48">The Big Bang Theory (2007)</a></h3><span style="font-weight: bold;">Sinopsis:</span>Serie de TV (2007-Actualidad). Leonard (Johnny Galecki) y Sheldon (Jim Parsons) son dos cerebros privilegiados que comparten piso. Aunque ambos se han doctorado en física y son capaces de calcular las probabilidades sobre la existencia de universos paralelos, no tienen ni la menor idea de cómo relacionarse con el resto del mundo, especialmente con las chicas. Penny (Kaley Cuoco), una vecina recién llegada que se instala en el piso de enfrente, es el polo opuesto a los dos amigos, de modo que su llegada altera la tranquila vida sentimental de Leonard y el desorden obsesivo-compulsivo de Sheldon. Penny es una chica tan normal que también perturba al resto de la pandilla: mientras que a Wolowitz (Simon Helberg) se le disparan las hormonas cada vez que la ve, Rajesh (Kunal Nayyar) se muestra incapaz de emitir un solo sonido en su presencia. (FILMAFFINITY)</div><a href="./the-big-bang-theory-f48"><img src="./caratula48" class="bimg" style="height: 150px; width: 101px; border-radius: 3px;"></a></div>

        ## Formatear 'data' para compatibilizar 'for'
        data = re.sub(
            r'<div style="height: 150px; margin-top: 10px;margin-bottom: 20px;">.*?' + \
             'center;">([^<]+)</div>.*?' + \
             '<a href="([^"]+)">' + \
             '([^<]+)</a>.*?' + \
             'Sinopsis:</span>([^<]+)</div>.*?' + \
             '<img src="([^"]+)".*?</a></div>',
            r'<patron>\2;\3;\5;\1|Sinopsis: \4</patron>',
            data
        )

        #<patron>./the-big-bang-theory-f48;The Big Bang Theory (2007);./caratula48;9.2|Sinopsis: Serie de TV (2007-Actualidad). Leonard (Johnny Galecki) y Sheldon (Jim Parsons) son dos cerebros privilegiados que comparten piso. Aunque ambos se han doctorado en física y son capaces de calcular las probabilidades sobre la existencia de universos paralelos, no tienen ni la menor idea de cómo relacionarse con el resto del mundo, especialmente con las chicas. Penny (Kaley Cuoco), una vecina recién llegada que se instala en el piso de enfrente, es el polo opuesto a los dos amigos, de modo que su llegada altera la tranquila vida sentimental de Leonard y el desorden obsesivo-compulsivo de Sheldon. Penny es una chica tan normal que también perturba al resto de la pandilla: mientras que a Wolowitz (Simon Helberg) se le disparan las hormonas cada vez que la ve, Rajesh (Kunal Nayyar) se muestra incapaz de emitir un solo sonido en su presencia. (FILMAFFINITY)</patron>

        patron = '<patron>([^;]+);([^;]+);([^;]+);([^<]+)</patron>'
    else:
        #<div onMouseOver="marcar_on('281', '1')" onMouseOut="marcar_of('281', '1')" class="divjustify" id="281" name="1" style="position: relative; margin-bottom: 5px; height:225px; width: 135px; margin-left: 19px; margin-right: 19px; text-align: center; sans-serif; color: #333;"><a href="./the-walking-dead-f281"><img title="The Walking Dead" class="bimg" style="border-radius: 3px; height:200px; width: 135px;" src="./caratula281"></a> <span style="text-overflow: ellipsis;overflow: hidden;width: 145px;white-space: nowrap;word-wrap: normal;text-align: center;display: block; margin-left: -5px;">The Walking Dead</span><div style="position: absolute;top: 0px;width: 30px; height: 30px;right: 0px;font-size: 13px; font-weight: bold; color: #f77f00; text-align: center; line-height: 30px; background-color: rgba(255, 255, 255, 0.8); border-bottom-left-radius: 3px;">9.3</div></div> <span id="pos1"></span>

        patron = '<a href="([^"]+)"><img title="([^"]+)".*?src="([^"]+)"></a>.*?<div[^>]+>([^<]+)</div>'

    matches = re.compile(patron,re.DOTALL).findall(data)

    for scrapedurl, scrapedtitle, scrapedthumbnail, scrapedpuntuacion in matches:
        url=urlparse.urljoin(host,scrapedurl)

        scrapedplot = ""
        ## Es una búsqueda?
        if item.extra == "search":
            ## Limpiar parámetro que se le añadió en la vuelta anterior
            item.url = re.sub(r'\?tipo=\d','',item.url)

            scrapedtitle = re.sub(r'\s\(\d+\)','',scrapedtitle)
            scrapedplot =  scrapedpuntuacion.split("|")[1]
            scrapedpuntuacion = scrapedpuntuacion.split("|")[0]

            ## Añadir tipo como parámetro a la url para filtrar (el párametro añadido no afecta a las solicitud)
            ## Es una serie o documental con espisodios?
            if scrapedplot.startswith('Sinopsis: Serie de TV') or scrapedplot.startswith('Sinopsis: Miniserie de TV'):
                item.url+= "?tipo=1"
            else:
                item.url+= "?tipo=2"

        ## 'extra' para usar '>> Añadir a la biblioteca...' en findvideos
        ## 'extra = ""' => Serie o documental con episodio
        ## 'extra = "strm"' => Película
        extra = ""
        if tipo(item.url) == 'findvideos':
            #function load_links(value){if(value == '0'){var value2 = '0';}else{var value2 = '1';}var url = './c_enlaces_n.php?ficha=278&id=' + value + '&key=ZHp6ZG0=';$("#enlaces" + value2).load(url);

            ficha = scrapertools.get_match(scrapedurl,'-f(\d+)$')
            scrapedurl = "./c_enlaces_n.php?ficha="+ficha+"&id=0&key=ZHp6ZG0="
            url=urlparse.urljoin(host,scrapedurl)

            extra = "strm"

        title = scrapedtitle+" ("+scrapedpuntuacion+")" 
        itemlist.append( Item(channel=__channel__, title=title, url=urlparse.urljoin(host,scrapedurl), action=tipo(item.url), thumbnail=urlparse.urljoin(host,scrapedthumbnail), show=scrapedtitle, plot=scrapedplot, extra=extra) )

    ## paginación
    patron = '<a href="([^"]+)">Siguiente</a>'
    matches = re.compile(patron,re.DOTALL).findall(data)
    if len(matches)>0:
        itemlist.append( Item(channel=__channel__, title=">> Página siguiente", url=urlparse.urljoin(host,matches[0].replace("amp;","")), action="fichas", extra=item.extra) )

    return itemlist

def tipo(url):
    lista = {'1':'episodios','2':'findvideos','3':'episodios'}
    return lista[ scrapertools.get_match(url,'tipo=(\d)') ]

def episodios(item):
    logger.info("pelisalacarta.channels.playmax episodios")

    itemlist = []

    ## Descarga la página
    data = scrapertools.downloadpageWithoutCookies(item.url)
    #data = scrapertools.cache_page(item.url)
    ## Agrupa los datos
    data = re.sub(r'\n|\r|\t|&nbsp;|<br>','',data)
    data = re.sub(r'\s+',' ',data)
    data = re.sub(r'<!--.*?-->','',data)

    #function load_links(value){var url = './c_enlaces.php?ficha=128&id=' + value + '&key=ZHB6YXE=';
    #^_______API+Número de la ficha:______^______Lo que usaremos________^______No nos interesa_____^

    patron = "var url = '([^']+)'"
    enlace = scrapertools.get_match(data,patron)

    #onclick="load_links_dos('5126', 'Viendo The Walking Dead 1x01 - Días pasados', 'Días pasados', '1X01', '5125', '5127')"
    #_API+Número de episodio_^_id_^_________^_________scrapedtitle_______________^__^___________No nos interesa___________^

    patron = "load_links_dos.'([^']+)', 'Viendo ([^']+)'"
    all_episodes = re.compile(patron,re.DOTALL).findall(data)

    for id, scrapedtitle in all_episodes:
        url = enlace + id + "&key=ZHp6ZG0="
        itemlist.append( Item(channel=__channel__, title=scrapedtitle, url=urlparse.urljoin(host,url), action="findvideos", thumbnail=item.thumbnail, show=item.show) )

    ## Opción "Añadir esta serie a la biblioteca de XBMC"
    if (config.get_platform().startswith("xbmc") or config.get_platform().startswith("boxee")) and len(itemlist)>0:
        itemlist.append( Item(channel=__channel__, title="Añadir esta serie a la biblioteca de XBMC", url=item.url, action="add_serie_to_library", extra="episodios", show=item.show) )

    return itemlist

def findvideos(item):
    logger.info("pelisalacarta.playmax findvideos")

    itemlist = []

    ## Descarga la página
    data = scrapertools.cache_page(item.url)
    ## Agrupa los datos
    data = re.sub(r'\n|\r|\t|&nbsp;|<br>','',data)
    data = re.sub(r'\s+',' ',data)
    data = re.sub(r'<!--.*?-->','',data)

    #<divdd class="capitulo" id="el500167"><a onclick="cvd('5126'); pulsed('500167')" href="./redirect.php?url=aHR0cDovL2FsbG15dmlkZW9zLm5ldC95ZTBmYzc3dXB6aXA=&id=281" target="_blank"><divd class="servidor"><img style="margin-top: 5px;" src="./styles/prosilver/imageset/allmyvideos.png"></divd><divd class="calidad">720p HD</divd><divd class="idioma">Inglés</divd><divd class="subtitulos">Sin subtítulos</divd><divd class="calidadaudio">Rip</divd></a><a href="./memberlist.php?mode=viewprofile&u=14204" target="_blank"><divd class="uploader">shara</divd></a><divd class="botonesenlaces"><divd><divd style="float: left;" id="linkmas500167"><divd class="positive_evaluation" onclick="valorar_noticia(500167, 1)"></divd></divd><divd style="float: left; color: #c21200;; text-align: center; width: 21px;" id="value_evaluation500167">-1</divd><divd style="float: left;" id="linkmenos500167"><divd onclick="valorar_noticia(500167, 2)" class="negative_evaluation"></divd></divd></divd></divd></divdd>

    patron = '<divdd class="capitulo" id="[^"]+">'
    patron+= '<a onclick="[^"]+" href="([^"]+)".*?'
    patron+= 'src="([^"]+)"></divd>'
    patron+= '<divd class="calidad">([^<]+)</divd>'
    patron+= '<divd class="idioma">([^<]+)</divd>'
    patron+= '<divd class="subtitulos">([^<]+)</divd>'
    patron+= '<divd class="calidadaudio">([^<]+)</divd>'

    matches = re.compile(patron,re.DOTALL).findall(data)

    if len(matches) == 0: 
        itemlist.append( Item(channel=__channel__, title ="No hay enlaces", folder=False ) )
        return itemlist

    for scrapedurl, scrapedthumbnail, calidad, idioma, subtitulos, calidadaudio in matches:

        servidor = scrapertools.get_match(scrapedthumbnail,'imageset/([^\.]+)\.')
        title = item.title + " [" + servidor + "] [" + calidad + "] [" + idioma + "] [" + subtitulos + "] [" + calidadaudio + "]"
        itemlist.append( Item(channel=__channel__, title =title, url=urlparse.urljoin(host,scrapedurl), action="play", thumbnail=urlparse.urljoin(host,scrapedthumbnail), fanart=item.thumbnail, show=item.show ) )

    # STRM para todos los enlaces de servidores disponibles con filtro para sólo películas
    # Si no existe el archivo STRM de la peícula muestra el item ">> Añadir a la biblioteca..."
    if item.extra == "strm":
        try: file_cine_library(item, itemlist)
        except: pass

    return itemlist

def file_cine_library(item, itemlist):
    import os
    from platformcode.xbmc import library
    librarypath = os.path.join(config.get_library_path(),"CINE")
    archivo = library.title_to_folder_name(item.show)
    strmfile = archivo+".strm"
    strmfilepath = os.path.join(librarypath,strmfile)

    if not os.path.exists(strmfilepath):
        itemlist.append( Item(channel=item.channel, title=">> Añadir a la biblioteca...", url=item.url, action="add_file_cine_library", extra="episodios", show=archivo) )

        return itemlist
    else:
        return

def add_file_cine_library(item):
    from platformcode.xbmc import library, xbmctools
    library.savelibrary( titulo=item.show , url=item.url , thumbnail=item.thumbnail , server=item.server , plot=item.plot , canal=item.channel , category="Cine" , Serie="" , verbose=False, accion="play_from_library", pedirnombre=False, subtitle=item.subtitle )

    itemlist = []
    itemlist.append(Item(title='El vídeo '+item.show+' se ha añadido a la biblioteca'))
    xbmctools.renderItems(itemlist, "", "", "")

    return

def play(item):
    logger.info("pelisalacarta.channels.playmax play url="+item.url)

    url = scrapertools.get_header_from_response(item.url, header_to_get="location")

    ## es una url de stopbot?
    if "stopbot" in url:

        ## solicitud 1/3
        ## Descarga la página
        data = scrapertools.cache_page(url)
        ## Agrupa los datos
        data = re.sub(r'\n|\r|\t|&nbsp;|<br>','',data)
        data = re.sub(r'\s+',' ',data)
        data = re.sub(r'<!--.*?-->','',data)

        ## stopbot - POST tipo 1
        #$.ajax({ type: "POST", url: "./bot.php", data: "key=qdWmuqaRhpbdxtrx5cK7lt%2FNb8+XvpvbvGXXvaSv5MnRmuA%3D%3D&id=6539&k=MXVUVzE5TFg3dExkMGclM0QlM0Q=&tipo=1",

        ## stopbot - POST tipo 2
        #$.ajax({ type: "POST", url: "./bot.php", data: "dc=" + m + "&key=qdWmuqaRhpbdxtrx5cK7lt%2FNb8+XvpvbvGXXvaSv5MnRmuA%3D%3D&id=6539&k=MXVUVzE5TFg3dExkMGclM0QlM0Q=&tipo=2",

        ## solicitud 2/3
        tipo_1 = scrapertools.get_match(data,'data: "([^"]+)"')
        tipo_1 = scrapertools.cache_page('http://stopbot.tk/bot.php',post=tipo_1)

        ## solicitud 3/3
        tipo_2 = scrapertools.get_match(data,'data: "dc=" . m . "([^"]+)"')
        tipo_2 = "dc="+tipo_1+tipo_2
        url = scrapertools.cache_page('http://stopbot.tk/bot.php',post=tipo_2)

        ## Reintentos de la última solicitud si no hay enlace.
        ## Lo normal es que si no aparce el enlace del vídeo a la primera aparece a la segunda
        while not url:
            url = scrapertools.cache_page('http://stopbot.tk/bot.php',post=tipo_2)

    itemlist = servertools.find_video_items(data=url)

    for videoitem in itemlist:
        videoitem.title = item.title
        videoitem.channel = __channel__

    return itemlist

def login():
    logger.info("pelisalacarta.channels.playmax login")

    login_form = "ucp.php?mode=login"
    data = scrapertools.cache_page(urlparse.urljoin(host,login_form))

    patron = '<input type="hidden" name="sid" value="([^"]+)" />'
    sid = scrapertools.find_single_match(data,patron)

    post = "username="+config.get_setting('playmaxuser')+"&password="+config.get_setting('playmaxpassword')+"&sid="+sid+"&redirect=index.php&login=Identificarse&redirect=.%2Fucp.php%3Fmode%3Dlogin"

    data = scrapertools.cache_page("http://playmax.es/ucp.php?mode=login",post=post)
